{
  description = "Advent of Code 2023";

  inputs = {
    nixpkgs.url = "github:nixos/nixpkgs/nixpkgs-unstable";
    flake-utils.url = "github:numtide/flake-utils";
  };

  outputs = { nixpkgs, flake-utils, ... }:
    flake-utils.lib.eachDefaultSystem (system:
      let
        pkgs = import nixpkgs { inherit system; };
        zig = pkgs.zig_0_11;
      in
      {
        devShells.default = pkgs.mkShellNoCC {
          buildInputs = [
            pkgs.aoc-cli
            zig
            pkgs.zls
          ];
        };

        packages.default = pkgs.stdenv.mkDerivation {
          name = "aoc23";
          src = pkgs.nix-gitignore.gitignoreSource [ ] ./.;

          nativeBuildInputs = [ zig.hook ];

          meta = {
            description = "Advent of Code 2023";
            homepage = "https://git.xeal.me/xeals/aoc23";
            license = nixpkgs.lib.licenses.mit;
            inherit (zig.meta) platforms;
          };
        };
      });
}
